Source-Changes-HG archive
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]
[src/trunk]: src/tests/usr.bin/cc Move common ASAN test case code into asan_c...
details: https://anonhg.NetBSD.org/src/rev/8fac98acf41a
branches: trunk
changeset: 838733:8fac98acf41a
user: mgorny <mgorny%NetBSD.org@localhost>
date: Tue Jan 29 19:56:37 2019 +0000
description:
Move common ASAN test case code into asan_common.subr
Reviewed by <kamil>
diffstat:
tests/usr.bin/cc/Makefile | 21 +-
tests/usr.bin/cc/asan_common.subr | 168 +++++++++++++++
tests/usr.bin/cc/t_asan_double_free.sh | 184 +----------------
tests/usr.bin/cc/t_asan_global_buffer_overflow.sh | 187 +----------------
tests/usr.bin/cc/t_asan_heap_overflow.sh | 183 +----------------
tests/usr.bin/cc/t_asan_off_by_one.sh | 204 +-----------------
tests/usr.bin/cc/t_asan_poison.sh | 237 +---------------------
tests/usr.bin/cc/t_asan_uaf.sh | 179 +---------------
8 files changed, 249 insertions(+), 1114 deletions(-)
diffs (truncated from 1531 to 300 lines):
diff -r 0de67d5f3437 -r 8fac98acf41a tests/usr.bin/cc/Makefile
--- a/tests/usr.bin/cc/Makefile Tue Jan 29 19:44:03 2019 +0000
+++ b/tests/usr.bin/cc/Makefile Tue Jan 29 19:56:37 2019 +0000
@@ -1,16 +1,19 @@
-# $NetBSD: Makefile,v 1.4 2018/05/02 18:46:05 kamil Exp $
+# $NetBSD: Makefile,v 1.5 2019/01/29 19:56:37 mgorny Exp $
.include <bsd.own.mk>
TESTSDIR= ${TESTSBASE}/usr.bin/cc
+ASAN_TESTS= #
+ASAN_TESTS+= t_asan_double_free
+ASAN_TESTS+= t_asan_global_buffer_overflow
+ASAN_TESTS+= t_asan_heap_overflow
+ASAN_TESTS+= t_asan_off_by_one
+ASAN_TESTS+= t_asan_poison
+ASAN_TESTS+= t_asan_uaf
+
TESTS_SH= #
-TESTS_SH+= t_asan_double_free
-TESTS_SH+= t_asan_global_buffer_overflow
-TESTS_SH+= t_asan_heap_overflow
-TESTS_SH+= t_asan_off_by_one
-TESTS_SH+= t_asan_poison
-TESTS_SH+= t_asan_uaf
+TESTS_SH+= $(ASAN_TESTS)
TESTS_SH+= t_ubsan_int_add_overflow
TESTS_SH+= t_ubsan_int_sub_overflow
TESTS_SH+= t_ubsan_int_neg_overflow
@@ -18,4 +21,8 @@
TESTS_SH+= t_ubsan_vla_out_of_bounds
TESTS_SH+= t_hello
+.for test in ${ASAN_TESTS}
+TESTS_SH_SRC_${test}= asan_common.subr ${test}.sh
+.endfor
+
.include <bsd.test.mk>
diff -r 0de67d5f3437 -r 8fac98acf41a tests/usr.bin/cc/asan_common.subr
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/usr.bin/cc/asan_common.subr Tue Jan 29 19:56:37 2019 +0000
@@ -0,0 +1,168 @@
+# $NetBSD: asan_common.subr,v 1.1 2019/01/29 19:56:37 mgorny Exp $
+#
+# Copyright (c) 2018, 2019 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+SUPPORT='n'
+test_target() {
+ if uname -m | grep -q "amd64"; then
+ SUPPORT='y'
+ fi
+
+ if uname -m | grep -q "i386"; then
+ SUPPORT='y'
+ fi
+}
+
+atf_test_case target_not_supported
+target_not_supported_head()
+{
+ atf_set "descr" "Test forced skip"
+}
+
+target_not_supported_body()
+{
+ atf_skip "Target is not supported"
+}
+
+# Add a new test case, with head & body.
+# asan_test_case <test-name> <description> <check-output>
+asan_test_case() {
+ atf_test_case "$1"
+ eval "$1_head() {
+ atf_set 'descr' 'compile and run \"$2\"'
+ atf_set 'require.progs' 'cc paxctl'
+ }"
+
+ atf_test_case "$1_profile"
+ eval "$1_head() {
+ atf_set 'descr' 'compile and run \"$2\" with profiling option'
+ atf_set 'require.progs' 'cc paxctl'
+ }"
+
+ atf_test_case "$1_pic"
+ eval "$1_head() {
+ atf_set 'descr' 'compile and run PIC \"$2\"'
+ atf_set 'require.progs' 'cc paxctl'
+ }"
+
+ atf_test_case "$1_pie"
+ eval "$1_head() {
+ atf_set 'descr' 'compile and run position independent (PIE) \"$2\"'
+ atf_set 'require.progs' 'cc paxctl'
+ }"
+
+ atf_test_case "${1}32"
+ eval "$1_head() {
+ atf_set 'descr' 'compile and run \"$2\" for/in netbsd32 emulation'
+ atf_set 'require.progs' 'cc paxctl file diff cat'
+ }"
+
+ eval "$1_body() {
+ echo \"\$ASAN_CODE\" > test.c
+ cc -fsanitize=address -o test test.c
+ paxctl +a test
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./test
+ }
+
+ $1_profile_body() {
+ echo \"\$ASAN_CODE\" > test.c
+ cc -fsanitize=address -o test -pg test.c
+ paxctl +a test
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./test
+ }
+
+ $1_pic_body() {
+ echo \"\$ASAN_CODE\" > test.c
+ cc -DPIC_FOO -fsanitize=address -fPIC -shared -o libtest.so test.c
+ cc -DPIC_MAIN -o test test.c -fsanitize=address -L. -ltest
+ paxctl +a test
+
+ export LD_LIBRARY_PATH=.
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./test
+ }
+
+ $1_pie_body() {
+ # check whether this arch supports -pice
+ if ! cc -pie -dM -E - < /dev/null 2>/dev/null >/dev/null; then
+ atf_set_skip 'cc -pie not supported on this architecture'
+ fi
+ echo \"\$ASAN_CODE\" > test.c
+ cc -fsanitize=address -o test -fpie -pie test.c
+ paxctl +a test
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./test
+ }
+
+ ${1}32_body() {
+ # check whether this arch is 64bit
+ if ! cc -dM -E - < /dev/null | fgrep -q _LP64; then
+ atf_skip 'this is not a 64 bit architecture'
+ fi
+ if ! cc -m32 -dM -E - < /dev/null 2>/dev/null > ./def32; then
+ atf_skip 'cc -m32 not supported on this architecture'
+ else
+ if fgrep -q _LP64 ./def32; then
+ atf_fail 'cc -m32 does not generate netbsd32 binaries'
+ fi
+ fi
+
+ echo \"\$ASAN_CODE\" > test.c
+ cc -fsanitize=address -o df32 -m32 test.c
+ cc -fsanitize=address -o df64 test.c
+ file -b ./df32 > ./ftype32
+ file -b ./df64 > ./ftype64
+ if diff ./ftype32 ./ftype64 >/dev/null; then
+ atf_fail 'generated binaries do not differ'
+ fi
+ echo '32bit binaries on this platform are:'
+ cat ./ftype32
+ echo 'While native (64bit) binaries are:'
+ cat ./ftype64
+ paxctl +a df32
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./df32
+
+# and another test with profile 32bit binaries
+ cc -fsanitize=address -o test -pg -m32 test.c
+ paxctl +a test
+ atf_check -s not-exit:0 -o not-match:'CHECK\n' -e match:'$3' ./test
+ }"
+}
+
+asan_add_test_cases() {
+ test_target
+ test $SUPPORT = 'n' && {
+ atf_add_test_case target_not_supported
+ return 0
+ }
+
+ atf_add_test_case "$1"
+# atf_add_test_case "$1_profile"
+ atf_add_test_case "$1_pic"
+ atf_add_test_case "$1_pie"
+# atf_add_test_case "${1}32"
+ # static option not supported
+ # -static and -fsanitize=address can't be used together for compilation
+ # (gcc version 5.4.0 and clang 7.1) tested on April 2nd 2018.
+}
diff -r 0de67d5f3437 -r 8fac98acf41a tests/usr.bin/cc/t_asan_double_free.sh
--- a/tests/usr.bin/cc/t_asan_double_free.sh Tue Jan 29 19:44:03 2019 +0000
+++ b/tests/usr.bin/cc/t_asan_double_free.sh Tue Jan 29 19:56:37 2019 +0000
@@ -1,6 +1,6 @@
-# $NetBSD: t_asan_double_free.sh,v 1.2 2018/07/16 07:25:58 kamil Exp $
+# $NetBSD: t_asan_double_free.sh,v 1.3 2019/01/29 19:56:37 mgorny Exp $
#
-# Copyright (c) 2018 The NetBSD Foundation, Inc.
+# Copyright (c) 2018, 2019 The NetBSD Foundation, Inc.
# All rights reserved.
#
# This code is derived from software contributed to The NetBSD Foundation
@@ -28,184 +28,22 @@
# POSSIBILITY OF SUCH DAMAGE.
#
-SUPPORT='n'
-test_target() {
- if uname -m | grep -q "amd64"; then
- SUPPORT='y'
- fi
-
- if uname -m | grep -q "i386"; then
- SUPPORT='y'
- fi
-}
-
-atf_test_case double_free
-double_free_head() {
- atf_set "descr" "compile and run \"Double Free example\""
- atf_set "require.progs" "cc paxctl"
-}
-
-atf_test_case double_free_profile
-double_free_profile_head() {
- atf_set "descr" "compile and run \"Double Free example\" with profiling option"
- atf_set "require.progs" "cc paxctl"
-}
-
-atf_test_case double_free_pic
-double_free_pic_head() {
- atf_set "descr" "compile and run PIC \"Double Free example\""
- atf_set "require.progs" "cc paxctl"
-}
-
-atf_test_case double_free_pie
-double_free_pie_head() {
- atf_set "descr" "compile and run position independent (PIE) \"Double Free example\""
- atf_set "require.progs" "cc paxctl"
-}
-
-atf_test_case double_free32
-double_free32_head() {
- atf_set "descr" "compile and run \"Double Free example\" for/in netbsd32 emulation"
- atf_set "require.progs" "cc paxctl file diff cat"
-}
-
-atf_test_case target_not_supported
-target_not_supported_head()
-{
- atf_set "descr" "Test forced skip"
-}
-
-double_free_body() {
- cat > test.c << EOF
-#include <stdlib.h>
-#include <string.h>
-#include <stdio.h>
-void foo(int index) { char *x = (char*)malloc(10 * sizeof(char)); memset(x, 0, 10); free(x); free(x - index); }
-int main(int argc, char **argv) { foo(argc - 1); printf("CHECK\n"); exit(0); }
-EOF
- cc -fsanitize=address -o test test.c
- paxctl +a test
- atf_check -s not-exit:0 -o not-match:"CHECK\n" -e match:"double-free" ./test
-}
-
-double_free_profile_body() {
- cat > test.c << EOF
-#include <stdlib.h>
-#include <string.h>
-#include <stdio.h>
-void foo(int index) { char *x = (char*)malloc(10 * sizeof(char)); memset(x, 0, 10); free(x); free(x - index); }
-int main(int argc, char **argv) { foo(argc - 1); printf("CHECK\n"); exit(0); }
-EOF
- cc -fsanitize=address -o test -pg test.c
- paxctl +a test
- atf_check -s not-exit:0 -o not-match:"CHECK\n" -e match:"double-free" ./test
-}
-
Home |
Main Index |
Thread Index |
Old Index